# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CloudAccountResultContent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'created_at': 'str',
        'updated_at': 'str',
        'owner': 'str',
        'owner_type': 'str',
        'org_id': 'str',
        'links': 'object',
        'name': 'str',
        'description': 'str',
        'cloud_account_type': 'str',
        'cloud_account_properties': 'dict(str, str)',
        'enabled_regions': 'list[RegionResultContent]',
        'custom_properties': 'dict(str, str)',
        'associated_mobility_cloud_account_ids': 'dict(str, str)',
        'tags': 'list[IaasapistorageprofilesidTags]',
        'healthy': 'bool',
        'in_maintenance_mode': 'bool'
    }

    attribute_map = {
        'id': 'id',
        'created_at': 'createdAt',
        'updated_at': 'updatedAt',
        'owner': 'owner',
        'owner_type': 'ownerType',
        'org_id': 'orgId',
        'links': '_links',
        'name': 'name',
        'description': 'description',
        'cloud_account_type': 'cloudAccountType',
        'cloud_account_properties': 'cloudAccountProperties',
        'enabled_regions': 'enabledRegions',
        'custom_properties': 'customProperties',
        'associated_mobility_cloud_account_ids': 'associatedMobilityCloudAccountIds',
        'tags': 'tags',
        'healthy': 'healthy',
        'in_maintenance_mode': 'inMaintenanceMode'
    }

    def __init__(self, id=None, created_at=None, updated_at=None, owner=None, owner_type=None, org_id=None, links=None, name=None, description=None, cloud_account_type=None, cloud_account_properties=None, enabled_regions=None, custom_properties=None, associated_mobility_cloud_account_ids=None, tags=None, healthy=None, in_maintenance_mode=None):  # noqa: E501
        """CloudAccountResultContent - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._created_at = None
        self._updated_at = None
        self._owner = None
        self._owner_type = None
        self._org_id = None
        self._links = None
        self._name = None
        self._description = None
        self._cloud_account_type = None
        self._cloud_account_properties = None
        self._enabled_regions = None
        self._custom_properties = None
        self._associated_mobility_cloud_account_ids = None
        self._tags = None
        self._healthy = None
        self._in_maintenance_mode = None
        self.discriminator = None
        self.id = id
        if created_at is not None:
            self.created_at = created_at
        if updated_at is not None:
            self.updated_at = updated_at
        if owner is not None:
            self.owner = owner
        if owner_type is not None:
            self.owner_type = owner_type
        if org_id is not None:
            self.org_id = org_id
        self.links = links
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        self.cloud_account_type = cloud_account_type
        self.cloud_account_properties = cloud_account_properties
        if enabled_regions is not None:
            self.enabled_regions = enabled_regions
        if custom_properties is not None:
            self.custom_properties = custom_properties
        if associated_mobility_cloud_account_ids is not None:
            self.associated_mobility_cloud_account_ids = associated_mobility_cloud_account_ids
        if tags is not None:
            self.tags = tags
        if healthy is not None:
            self.healthy = healthy
        if in_maintenance_mode is not None:
            self.in_maintenance_mode = in_maintenance_mode

    @property
    def id(self):
        """Gets the id of this CloudAccountResultContent.  # noqa: E501

        The id of this resource instance  # noqa: E501

        :return: The id of this CloudAccountResultContent.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CloudAccountResultContent.

        The id of this resource instance  # noqa: E501

        :param id: The id of this CloudAccountResultContent.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def created_at(self):
        """Gets the created_at of this CloudAccountResultContent.  # noqa: E501

        Date when the entity was created. The date is in ISO 8601 and UTC.  # noqa: E501

        :return: The created_at of this CloudAccountResultContent.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this CloudAccountResultContent.

        Date when the entity was created. The date is in ISO 8601 and UTC.  # noqa: E501

        :param created_at: The created_at of this CloudAccountResultContent.  # noqa: E501
        :type: str
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this CloudAccountResultContent.  # noqa: E501

        Date when the entity was last updated. The date is ISO 8601 and UTC.  # noqa: E501

        :return: The updated_at of this CloudAccountResultContent.  # noqa: E501
        :rtype: str
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this CloudAccountResultContent.

        Date when the entity was last updated. The date is ISO 8601 and UTC.  # noqa: E501

        :param updated_at: The updated_at of this CloudAccountResultContent.  # noqa: E501
        :type: str
        """

        self._updated_at = updated_at

    @property
    def owner(self):
        """Gets the owner of this CloudAccountResultContent.  # noqa: E501

        Email of the user or display name of the group that owns the entity.  # noqa: E501

        :return: The owner of this CloudAccountResultContent.  # noqa: E501
        :rtype: str
        """
        return self._owner

    @owner.setter
    def owner(self, owner):
        """Sets the owner of this CloudAccountResultContent.

        Email of the user or display name of the group that owns the entity.  # noqa: E501

        :param owner: The owner of this CloudAccountResultContent.  # noqa: E501
        :type: str
        """

        self._owner = owner

    @property
    def owner_type(self):
        """Gets the owner_type of this CloudAccountResultContent.  # noqa: E501

        Type of a owner(user/ad_group) that owns the entity.  # noqa: E501

        :return: The owner_type of this CloudAccountResultContent.  # noqa: E501
        :rtype: str
        """
        return self._owner_type

    @owner_type.setter
    def owner_type(self, owner_type):
        """Sets the owner_type of this CloudAccountResultContent.

        Type of a owner(user/ad_group) that owns the entity.  # noqa: E501

        :param owner_type: The owner_type of this CloudAccountResultContent.  # noqa: E501
        :type: str
        """

        self._owner_type = owner_type

    @property
    def org_id(self):
        """Gets the org_id of this CloudAccountResultContent.  # noqa: E501

        The id of the organization this entity belongs to.  # noqa: E501

        :return: The org_id of this CloudAccountResultContent.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this CloudAccountResultContent.

        The id of the organization this entity belongs to.  # noqa: E501

        :param org_id: The org_id of this CloudAccountResultContent.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def links(self):
        """Gets the links of this CloudAccountResultContent.  # noqa: E501

        hrefs links  # noqa: E501

        :return: The links of this CloudAccountResultContent.  # noqa: E501
        :rtype: object
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this CloudAccountResultContent.

        hrefs links  # noqa: E501

        :param links: The links of this CloudAccountResultContent.  # noqa: E501
        :type: object
        """
        if links is None:
            raise ValueError("Invalid value for `links`, must not be `None`")  # noqa: E501

        self._links = links

    @property
    def name(self):
        """Gets the name of this CloudAccountResultContent.  # noqa: E501

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :return: The name of this CloudAccountResultContent.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CloudAccountResultContent.

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :param name: The name of this CloudAccountResultContent.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this CloudAccountResultContent.  # noqa: E501

        A human-friendly description.  # noqa: E501

        :return: The description of this CloudAccountResultContent.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CloudAccountResultContent.

        A human-friendly description.  # noqa: E501

        :param description: The description of this CloudAccountResultContent.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def cloud_account_type(self):
        """Gets the cloud_account_type of this CloudAccountResultContent.  # noqa: E501

        Cloud account type  # noqa: E501

        :return: The cloud_account_type of this CloudAccountResultContent.  # noqa: E501
        :rtype: str
        """
        return self._cloud_account_type

    @cloud_account_type.setter
    def cloud_account_type(self, cloud_account_type):
        """Sets the cloud_account_type of this CloudAccountResultContent.

        Cloud account type  # noqa: E501

        :param cloud_account_type: The cloud_account_type of this CloudAccountResultContent.  # noqa: E501
        :type: str
        """
        if cloud_account_type is None:
            raise ValueError("Invalid value for `cloud_account_type`, must not be `None`")  # noqa: E501

        self._cloud_account_type = cloud_account_type

    @property
    def cloud_account_properties(self):
        """Gets the cloud_account_properties of this CloudAccountResultContent.  # noqa: E501

        Cloud account specific properties  # noqa: E501

        :return: The cloud_account_properties of this CloudAccountResultContent.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._cloud_account_properties

    @cloud_account_properties.setter
    def cloud_account_properties(self, cloud_account_properties):
        """Sets the cloud_account_properties of this CloudAccountResultContent.

        Cloud account specific properties  # noqa: E501

        :param cloud_account_properties: The cloud_account_properties of this CloudAccountResultContent.  # noqa: E501
        :type: dict(str, str)
        """
        if cloud_account_properties is None:
            raise ValueError("Invalid value for `cloud_account_properties`, must not be `None`")  # noqa: E501

        self._cloud_account_properties = cloud_account_properties

    @property
    def enabled_regions(self):
        """Gets the enabled_regions of this CloudAccountResultContent.  # noqa: E501

        A list of regions that are enabled for provisioning on this cloud account  # noqa: E501

        :return: The enabled_regions of this CloudAccountResultContent.  # noqa: E501
        :rtype: list[RegionResultContent]
        """
        return self._enabled_regions

    @enabled_regions.setter
    def enabled_regions(self, enabled_regions):
        """Sets the enabled_regions of this CloudAccountResultContent.

        A list of regions that are enabled for provisioning on this cloud account  # noqa: E501

        :param enabled_regions: The enabled_regions of this CloudAccountResultContent.  # noqa: E501
        :type: list[RegionResultContent]
        """

        self._enabled_regions = enabled_regions

    @property
    def custom_properties(self):
        """Gets the custom_properties of this CloudAccountResultContent.  # noqa: E501

        Additional properties that may be used to extend the base type.  # noqa: E501

        :return: The custom_properties of this CloudAccountResultContent.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_properties

    @custom_properties.setter
    def custom_properties(self, custom_properties):
        """Sets the custom_properties of this CloudAccountResultContent.

        Additional properties that may be used to extend the base type.  # noqa: E501

        :param custom_properties: The custom_properties of this CloudAccountResultContent.  # noqa: E501
        :type: dict(str, str)
        """

        self._custom_properties = custom_properties

    @property
    def associated_mobility_cloud_account_ids(self):
        """Gets the associated_mobility_cloud_account_ids of this CloudAccountResultContent.  # noqa: E501

        Workload mobility associations to other vSphere cloud accounts. ID refers to an associated cloud account, and directionality can be unidirectional or bidirectional. Only supported on vSphere Cloud Accounts.  # noqa: E501

        :return: The associated_mobility_cloud_account_ids of this CloudAccountResultContent.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._associated_mobility_cloud_account_ids

    @associated_mobility_cloud_account_ids.setter
    def associated_mobility_cloud_account_ids(self, associated_mobility_cloud_account_ids):
        """Sets the associated_mobility_cloud_account_ids of this CloudAccountResultContent.

        Workload mobility associations to other vSphere cloud accounts. ID refers to an associated cloud account, and directionality can be unidirectional or bidirectional. Only supported on vSphere Cloud Accounts.  # noqa: E501

        :param associated_mobility_cloud_account_ids: The associated_mobility_cloud_account_ids of this CloudAccountResultContent.  # noqa: E501
        :type: dict(str, str)
        """
        allowed_values = ["UNIDIRECTIONAL", "BIDIRECTIONAL"]  # noqa: E501
        if not set(associated_mobility_cloud_account_ids.keys()).issubset(set(allowed_values)):
            raise ValueError(
                "Invalid keys in `associated_mobility_cloud_account_ids` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(associated_mobility_cloud_account_ids.keys()) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._associated_mobility_cloud_account_ids = associated_mobility_cloud_account_ids

    @property
    def tags(self):
        """Gets the tags of this CloudAccountResultContent.  # noqa: E501

        A set of tag keys and optional values that were set on the Cloud Account  # noqa: E501

        :return: The tags of this CloudAccountResultContent.  # noqa: E501
        :rtype: list[IaasapistorageprofilesidTags]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this CloudAccountResultContent.

        A set of tag keys and optional values that were set on the Cloud Account  # noqa: E501

        :param tags: The tags of this CloudAccountResultContent.  # noqa: E501
        :type: list[IaasapistorageprofilesidTags]
        """

        self._tags = tags

    @property
    def healthy(self):
        """Gets the healthy of this CloudAccountResultContent.  # noqa: E501

        Indicates the health of the cloud account. If false, this means there is no connectivity to the cloud provider or the credentials are invalid.  # noqa: E501

        :return: The healthy of this CloudAccountResultContent.  # noqa: E501
        :rtype: bool
        """
        return self._healthy

    @healthy.setter
    def healthy(self, healthy):
        """Sets the healthy of this CloudAccountResultContent.

        Indicates the health of the cloud account. If false, this means there is no connectivity to the cloud provider or the credentials are invalid.  # noqa: E501

        :param healthy: The healthy of this CloudAccountResultContent.  # noqa: E501
        :type: bool
        """

        self._healthy = healthy

    @property
    def in_maintenance_mode(self):
        """Gets the in_maintenance_mode of this CloudAccountResultContent.  # noqa: E501

        Indicates if the  cloud account is undergoing maintenance. If true, it can't be used for provisioning and scheduled enumeration is not triggered.  # noqa: E501

        :return: The in_maintenance_mode of this CloudAccountResultContent.  # noqa: E501
        :rtype: bool
        """
        return self._in_maintenance_mode

    @in_maintenance_mode.setter
    def in_maintenance_mode(self, in_maintenance_mode):
        """Sets the in_maintenance_mode of this CloudAccountResultContent.

        Indicates if the  cloud account is undergoing maintenance. If true, it can't be used for provisioning and scheduled enumeration is not triggered.  # noqa: E501

        :param in_maintenance_mode: The in_maintenance_mode of this CloudAccountResultContent.  # noqa: E501
        :type: bool
        """

        self._in_maintenance_mode = in_maintenance_mode

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CloudAccountResultContent, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CloudAccountResultContent):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
